#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
short width=32;
typedef unsigned char uchar;
struct Head {
  uchar manuf;
  uchar hard;
  uchar encod;
  uchar bitpx;
  short x1;
  short y1;
  short x2;
  short y2;
  short hres;
  short vres;
  uchar clrma[48];
  uchar vmode;
  uchar nplanes;
  short bplin;
  short palinfo;
  short shres;
  short svres;
  uchar xtra[54];
};
short linesave(short n,uchar *line,FILE*f){
  uchar *buf=new uchar[2*n];
  assert(buf!=NULL);
  uchar *pos=line;
  uchar *bpos=buf;
  short pc=0;
  short toread=n;
  uchar curbyte;
  uchar repeat;
  for(;;){
    if(toread==0) break;
    curbyte=*pos;
    pos++;
    repeat=1;
    toread--;
    while((*pos==curbyte)&&(toread>0)){
      pos++; repeat++; toread--;
      if (toread==0) break;
      if (repeat==63) break;
    }
    if (repeat>1) {
      *bpos=(0xC0|repeat); bpos++;
      *bpos=curbyte; bpos++;
      pc+=2;
    } else if (curbyte<0xC0){
	*bpos=curbyte; bpos++;
	pc++;
    } else {
	*bpos=0xC1; bpos++;
	*bpos=curbyte; bpos++;
	pc+=2;
    }
  }
  short r=fwrite(buf,1,pc,f)==pc;
  delete buf;
  return r;
}
#define BIT(x) (0x80>>((x)&7))
void setbit(uchar *a,short x,uchar bit){
  short p=x/8;
  uchar bt=x%8;
  uchar mask=BIT(bt);
  a[p]|=mask;
  if(bit==0) a[p]^=mask;
}
short quebit(uchar *a,short x){
  short p=x/8;
  uchar bt=x%8;
  uchar mask=BIT(bt);
  if((a[p]&mask)==0){
    return 0;
  } else {
    return 1;
  }
}
short processLine(short n,uchar*line,FILE*f){
  uchar c;

  for(short i=0;i<width;i++) line[i]=rand()&256;

  for(short x=width*8;x<n*8;x++){
    if(quebit(line,x)==0){
      setbit(line,x,quebit(line,x-width*8+width));
    } else {
      setbit(line,x,quebit(line,x-width*8+(x/(width*10))%(width/2)));
    }
  }

  return linesave(n,line,f);
}
main(){
  printf("Width=");
  scanf("%d",&width);
  short bufflen=5000;
  FILE *in=fopen("in.pcx","rb");
  Head h;
  fread(&h,sizeof(Head),1,in);
  FILE *out=fopen("out.pcx","wb");
  uchar buf[5000];
  uchar res[5000];
  uchar *b,c,bits;
  fwrite(&h,1,sizeof(Head),out);
  short k,n,y,l,npl,repcnt=0;
  short sizeY=h.y2-h.y1+1;
  short rest=fread(buf,1,bufflen,in);
  b=buf;
  printf("Came here... sizeY=%d, sizeX=%d\n",sizeY,h.bplin*8);
  for (y=0;y<sizeY;y++){
    printf("\r%d",y);
    for(k=0;k<h.bplin;k+=repcnt){
      if(rest==0){
	rest=fread(buf,1,bufflen,in);
	b=buf;
      }
      c=b[0]; b++; rest--;
      if((c&0xC0)==0xC0){
	repcnt=(c&0x3F);
	if(rest==0) {
	  rest=fread(buf,1,bufflen,in);
	  b=buf;
	}
	bits=b[0]; b++; rest--;
      } else {
	repcnt=1;
	bits=c;
      }
      for (l=0;l<repcnt;l++) res[k+l]=bits;
    }
    processLine(h.bplin,res,out);
  }
  fclose(out);
}
