{$R+} {$M 65500,0,0}
program test;
  const n=500;
  type arr=array[1..n] of integer;
  var m: arr; i: integer;

  procedure fill (var  x: arr);
    var i: integer;
  begin
    for i:=1 to n do begin
      x[i]:= Random(50);
    end;
  end;

  procedure sort (var  x: arr);
    var u, k: integer;
    procedure exchange(i, j: integer);
      var tmp: integer;
    begin
      tmp  := x[i]; x[i] := x[j]; x[j] := tmp;
    end;
    procedure restore (s: integer);
      var right: boolean;
      begin
      right:= (2*s+1 <= k) and (x[2*s+1] > x[s]);
      while right or ((2*s <= k) and (x[2*s] > x[s])) do begin
        if right and (x[2*s+1]>x[2*s]) then begin
          exchange (s, 2*s+1);
          s := 2*s+1;
        end else begin
          exchange (s, 2*s);
          s := 2*s;
        end;
        right:= (2*s+1 <= k) and (x[2*s+1] > x[s]);
      end;
    end;
  begin
    k:=n;
    u:=n;
    while u <> 0 do begin
      restore (u);
      u := u - 1;
    end;
    while k <> 1 do begin
      exchange (1, k);
      k := k - 1;
      restore (1);
    end;
  end;

  procedure sort2 (var x:arr; l,r:integer);
    var b:integer; ll,rr,mm: integer;
    procedure exchange(i, j: integer);
      var tmp: integer;
      begin
      tmp  := x[i];
      x[i] := x[j];
      x[j] := tmp;
    end;
  begin
   {writeln(l,'--',r);}
    if r>l+2 then begin
      b:= x[l+1+Random(r-l)];
      ll:=l;rr:=r;mm:=l;
      {ਠ: x[l..ll]<b; x[ll+1..mm]=b; a[rr+1]..a[r]>b}
      while mm <> rr do begin
        if x[mm+1]=b then begin
          mm:=mm+1;
        end else if x[mm+1]>b then begin
          exchange(mm+1,rr);
          rr:=rr-1;
        end else begin {x[mm+1]<b}
          exchange(mm+1,ll+1);
          ll:=ll+1; mm:=mm+1;
        end;
      end;
      sort2(x, l, ll);
      sort2(x, rr, r);
    end else if r=l+2 then begin
      if x[l+1]>x[r] then exchange(l+1,r);
    end;
  end;

  procedure output (var x:arr);
    var i,j:integer;
  begin
    for i:=1 to n do begin
      for j:=0 to x[i]+1 do write('*'); writeln;
    end;
  end;

begin
  fill(m);
  readln(i);
  write('Sorting...');
  if i=0 then sort(m) else sort2(m,0,n);
  writeln('done');
  output(m);
end.
